package mockrequest

import (
	"encoding/json"
	"errors"
)

// A Service implements the request usecases (mock)
type Service struct {
	throwError bool
}

// NewService creates a new service (mock)
func NewService() *Service {
	return &Service{
		throwError: false,
	}
}

// SendAQLQuery sends the query to arangoDB and parses the result (mock)
func (s *Service) SendAQLQuery(query string, username string, password string, hostname string, port int, database string) (*[]byte, error) {
	//mockResult := make(map[string][]entity.Document)
	mockResult, _ := json.Marshal("test")

	if !s.throwError {
		return &mockResult, nil
	}
	return nil, errors.New("Database error")
}

// ToggleError decides whether the convert function throws an error
func (s *Service) ToggleError() {
	s.throwError = !s.throwError
}
